BouncingBall ball1;
BouncingBall ball2;
ArrayList balls = new ArrayList();

HandCapture   handCapture;
boolean       drawFlag=false;


PVector      p1 = new PVector();
PVector      p2 = new PVector();
boolean      drag = false;
boolean      p1Set = false;

void setup() {
  
  handCapture = new HandCapture(this);
  
  size(handCapture.width(), handCapture.height());
  println("Fesntergrösse: " + handCapture.width() + " - " + handCapture.height());
  smooth();  
  
}


void draw() {
  
  // update the hand tracking
  handCapture.update();
  
  
  // draw cam images
  if(drawFlag)
    image(handCapture.depthImage(),0,0);
  else
    image(handCapture.rgbImage(),0,0);
    
  
  // ghosting
  fill(255,255,255,60);
  rect(0,0,width,height);
  
  if (drag) { 
    // zeichne die abschussrichtung
    line(p1.x,p1.y,p2.x,p2.y);
  }
  
  // zeichne den ball
  for (int i = balls.size()-1; i >= 0; i--) {
    
    BouncingBall ball = (BouncingBall)balls.get(i);
    ball.draw();
    
  }
  
  // handgesten
  if(handCapture.isHandTracked()) {
   
    PVector handPos = handCapture.handPos();
    println(handPos.x + " " + handPos.y + " " + handPos.z);
      
      drag = true;
      if(!p1Set)
        setP1(handPos.x,handPos.y,handPos.z);
      
      p2.set(handPos.x,handPos.y,handPos.z);
      
      if(p1.z > p2.z + 200) {
        ballGo();
      }
      
      pushStyle();
        stroke(255,0,0);
        strokeWeight(8);
        
        point(handPos.x,handPos.y);
      popStyle();   
      
  }

}



void setP1 (float x, float y, float z) {
  
  p1.set(x,y,z);
  p1Set = true;
  
}

void mousePressed() {
  drag = true;
  p1.set(mouseX,mouseY,0);
  p2.set(mouseX,mouseY,0);
}


void mouseDragged() {
  p2.set(mouseX,mouseY,0);
}


void ballGo() {
  
  drag = false;
  p1Set = false;
  
  // abschuss staerke berechnen
  PVector dir = PVector.sub(p2,p1);
  // laenge verkuerzen
  dir.mult(.09);
  
  // der ball wird neu ausgerichtet
  int tempSize = (int)random(50, 200);
  BouncingBall tempBall = new BouncingBall(tempSize, tempSize);
  tempBall.set(new PVector(mouseX,mouseY),dir,0.995);
  balls.add(tempBall);
  
}


void keyPressed()
{
  switch(key)
  {
  case ' ':
    drawFlag = !drawFlag;
    break;
  }
}









// -----------------------------------------------------------------
// hand events

void onCreateHands(int handId,PVector pos,float time)
{
  handCapture.onCreateHands(handId,pos,time);
}

void onUpdateHands(int handId,PVector pos,float time)
{
  handCapture.onUpdateHands(handId,pos,time);
}

void onDestroyHands(int handId,float time)
{
  handCapture.onDestroyHands(handId,time);
}

void onRecognizeGesture(String strGesture, PVector idPosition, PVector endPosition)
{
  handCapture.onRecognizeGesture(strGesture,idPosition,endPosition);
}

void onProgressGesture(String strGesture, PVector position,float progress)
{
  handCapture.onProgressGesture(strGesture,position,progress);
}
  
